//Ridici jednotka obehoveho cerpadla TUV
//Pouziva cidla KTY81/210, zobrazeni na LCD
//ovladani cerpadla pres optotoriac
//Arduino 1.5.5-r2
//verze 2
//2.9.2014
//Tomas Nevrela; tnweb.tode.cz
//pripojeni delice rezistoru s termocidlem KTY81/210, ktere je pripojeno ke GND.
#include <EEPROM.h>
#include "EEPROMAnything.h"
#include <LiquidCrystal.h>
// LiquidCrystal lcd(rs, en, d4, d5, d6, d7); //
   LiquidCrystal lcd(9 , 8 , 7 , 6 , 5 , 4 ); 


#define Buttons  A2 //pripojene tlacitka
#define KeyExit  20 
#define KeyUp    30
#define KeyDown  40
#define KeySel   50
#define KeyInv   60 //neplatna hodnota tlacitka
#define menuTimeExit 20000
#define blikper 600
#define MAX_T_KOT 90  //max. teplota kotle pri ktere se nucene spusti cerpadlo
#define R25 2000 //referencni odpor termocidla pri 25°C
#define ucc 5 //napajeci napeti delice
#define cerp 10 //vystupni pin ovladani cerpadla
#define backled 11 //pin pro ovládaní podsvícení
#define cidlo_K A0 //cidlo teploty kotle KTY81/210
#define cidlo_B A1 //cidlo teploty bojleru KTY81/210
#define permereni 1000 //perioda mereni teplot
int R = 2192; // hodnota rezistoru v delici s termocidlem
int TeplKotle; //skutecna teplota kotle
int PozTepl = 60; //pozadovana teplota TUV
int MinTepl = 40; // min teplota kotle pri ktere zapne cerpadlo
int TeplBojl; //skutecna teplota bojleru (TUV)
int HystMax = 5; // hystereze pri max teplote kotle
int HystKotel = 4; // hystereze teploty bojler-kotel
int HystTUV = 1; //hystereze TUV
byte backlight = 10; // hodnota podsviceni LCD
boolean StavCerp = false;// stav cerpadla
boolean KotelMax = false;// prekrocena teplota kotle
boolean showStatus, star; // 
int klavesa; 
char tmp[8];
byte offset, whichkey;
long sumatemp;
long sumatemp1;
unsigned long currentMillis; 
unsigned long menuTime = 0;
unsigned long casmereni = 0;
unsigned long bliktime = 0;
byte cerp_1[8] = {0b00000,0b00010,0b11110,0b01110,0b01111,0b01000,0b00000,0b00000};
byte cerp_2[8] = {0b00000,0b01000,0b01111,0b01110,0b11110,0b00010,0b00000,0b00000};
byte stupen[8] = {0b01100,0b10010,0b10010,0b01100,0b00000,0b00000,0b00000,0b00000};  
prog_char string_0[] PROGMEM =   "Pozad.tepl. TUV ";  //0
prog_char string_1[] PROGMEM =   "Hystereze TUV   ";  //1
prog_char string_2[] PROGMEM =   "Hyst.kotel / TUV";  //2
prog_char string_3[] PROGMEM =   "Min. tepl. kotle";  //3
prog_char string_4[] PROGMEM =   "Man.ovl.cerpadla";  //4
prog_char string_5[] PROGMEM =   "Podsviceni LCD  ";  //5
prog_char string_6[] PROGMEM =   "   ***MENU***   ";  //6
prog_char string_7[] PROGMEM =   " ukladam...     ";  //7
prog_char string_8[] PROGMEM =   "RIDICI JEDNOTKA";   //8
prog_char string_9[] PROGMEM =   " CERPADLA TUV";     //9 
prog_char string_10[] PROGMEM =  "verze: 02";        //10 
prog_char string_11[] PROGMEM =  "2.9.2014";        //11 
prog_char string_12[] PROGMEM =  "Tomas Nevrela";    //12 
prog_char string_13[] PROGMEM =  "tnweb.tode.cz";    //13 
prog_char string_14[] PROGMEM =  "vadne termocidlo"; //14 
prog_char string_15[] PROGMEM =  "kotle";            //15 
prog_char string_16[] PROGMEM =  "bojleru";          //16 
 
PROGMEM const char *StringTable[] = {
  string_0, //0
  string_1, //1
  string_2, //2
  string_3, //3         
  string_4, //4
  string_5, //5
  string_6, //6
  string_7, //7
  string_8, //8
  string_9, //9
  string_10, //10
  string_11, //11
  string_12, //12
  string_13, //13
  string_14, //14
  string_15, //15
  string_16, //16
 };
 

 
///////////////////////////SETUP///////////////////////////////////////
void setup()         
{

//Serial.begin(9600);
lcd.begin(16, 2);
lcd.createChar(1, cerp_1); 
lcd.createChar(2, cerp_2);
lcd.createChar(3, stupen); 
// zapis tovarnich hodnot pri prvnim spusteni programu
//EEPROM_writeAnything(10,PozTepl);
//EEPROM_writeAnything(20,MinTepl);
//EEPROM_writeAnything(30,HystKotel);
//EEPROM_writeAnything(40,HystTUV);
//EEPROM_writeAnything(50,backlight);

EEPROM_readAnything(10,PozTepl);
EEPROM_readAnything(20,MinTepl);
EEPROM_readAnything(30,HystKotel);
EEPROM_readAnything(40,HystTUV);
EEPROM_readAnything(50,backlight);
showStatus=false;
pinMode(cerp, OUTPUT);
pinMode(backled, OUTPUT);
set_backlight();
digitalWrite(cerp,LOW);
lcd.clear();
PrintLCDAt_P(8, 0, 0);
PrintLCDAt_P(9, 0, 1);
delay(3000);
lcd.clear();
PrintLCDAt_P(10, 0, 0);
PrintLCDAt_P(11, 0, 1);
lcd.setCursor(0, 0);
delay(3000);
lcd.clear();
PrintLCDAt_P(12, 0, 0);
PrintLCDAt_P(13, 0, 1);
delay(3000);
lcd.clear();
delay(30);
}
///////////////////////////LOOP/////////////////////////////////////// 
void loop()                     
{
klavesa = KeyScan();
if (klavesa == KeySel) showStatus=true;
if(showStatus)mainMenu(); 
currentMillis = millis();
if (currentMillis - casmereni >= permereni){
zmer_teploty();
casmereni = currentMillis;
}
//kontrola termocidel
if ((sumatemp > 690) || (sumatemp < 390)) {
lcd.clear();
PrintLCDAt_P(14, 0, 0);
PrintLCDAt_P(15, 0, 1);
delay(5000);
lcd.clear();
}
else if ((sumatemp1 > 690) || (sumatemp1 < 390)) {
lcd.clear();
PrintLCDAt_P(14, 0, 0);
PrintLCDAt_P(16, 0, 1);
delay(5000);
lcd.clear();
}
else {
//pokud jsou termocidla v poradku, ovladej cerpadlo a zobraz teploty
ovl_cerp();
lcd.setCursor(0, 1);
lcd.print("KOT   TUV   ZAD");
lcd.setCursor(0, 0);
lcd.print(TeplKotle);
lcd.write(3);//znacka stupne
lcd.print("C ");
lcd.setCursor(6, 0);
lcd.print(TeplBojl);
lcd.write(3);//znacka stupne
lcd.print("C ");
lcd.setCursor(12, 0);
lcd.print(PozTepl);
lcd.write(3);//znacka stupne
lcd.print("C ");
// animace cerpadla na lcd pri chodu 
currentMillis = millis();
if ((StavCerp)&&(currentMillis - bliktime >= blikper)) {
  if (star){
  lcd.setCursor(15, 1);
  lcd.write(1);
}
else {
 lcd.setCursor(15, 1);
  lcd.write(2); 
}
star = !star;
bliktime = currentMillis;
}
if (!StavCerp){
lcd.setCursor(15, 1);
lcd.print(" "); 
}
delay(50);
}
}

//====================================================================
// odecte analogove hodnoty cidel
void zmer_teploty(){
sumatemp = 0;
sumatemp1 = 0;
   for (int i=1; i <= 100; i++){
   sumatemp = sumatemp + analogRead(cidlo_K);
   sumatemp1 = sumatemp1 + analogRead(cidlo_B);
}
 sumatemp = sumatemp/100;// vypocte prumer ze 100 vzorku
 sumatemp1 = sumatemp1/100;// vypocte prumer ze 100 vzorku
TeplKotle = vypocet(sumatemp);
TeplBojl = vypocet(sumatemp1);
}
//====================================================================
// vypocte z analogovych hodnot teploty
int vypocet(int value){
float ukty = ucc * value / 1024.0 ;//vypocet napeti na senzoru
// alfa x R25
float a = 0.007874 * R25;
// beta x R25
float b = 0.00001874 * R25;
// koeficient c 
float c = R25 - R * ukty / (ucc - ukty);
float delta = a * a - 4 * b * c;
float delta1 = sqrt (delta);
float x2 =(-a + delta1)/(2 * b);
float temp1 = x2 + 25 ;
int teplota = temp1;//prevod na int
return teplota;
}

//====================================================================
void ovl_cerp(){
 //ochrana, pri prekroceni teploty kotle zapne cerpadlo
 if (TeplKotle > MAX_T_KOT){
  digitalWrite (cerp,HIGH);
  StavCerp = true;
  KotelMax = true;
 }
 else if (KotelMax && TeplKotle + HystMax < MAX_T_KOT){
  digitalWrite (cerp,LOW);
  StavCerp = false;
  KotelMax = false;
 }

//zapnuti cerpadla podle pozadovane teploty
if (!KotelMax && (TeplKotle > TeplBojl + HystKotel)&&(TeplBojl <= PozTepl-HystTUV) && (TeplKotle > MinTepl)){
digitalWrite (cerp,HIGH);
StavCerp = true;
}
//vypnuti cerpadla podle pozadovane teploty
else if (!KotelMax && ((TeplKotle < TeplBojl + HystKotel)||(TeplBojl > PozTepl) || (TeplKotle < MinTepl ))) {
digitalWrite (cerp,LOW);
StavCerp = false;
}
}

//====================================================================
// nastaveni podsviceni LCD
void set_backlight(){
int x = (10 - backlight)*27;
analogWrite(backled,x);
}

//====================================================================
// LCD menu
void mainMenu() {

  offset=0;
  menuTime = millis();
  do {
    delay(50);
    lcd.clear();
    PrintLCD_P(6); 
    PrintLCDAt_P(offset , 0, 1);
    delay(200);
    whichkey = PollKey();
        switch(whichkey) {
       case KeyExit:showStatus=false;break;
       case KeyUp:
          if (offset > 0) offset--;
          break;
       case KeyDown:
          if (offset < 5) offset++;
          break;
       case KeySel:
          switch (offset) {
             case 0: //nastaveni pozadovane teploty TUV 
                menu_teplotaTUV();
                break;
             case 1: //nastaveni hystereze TUV
                menu_hysTUV();
                break;
             case 2: //nastaveni hystereze kotel-TUV
                menu_hysKotelTUV();
                break;
             case 3: //nastaveni min. teploty kotle
                menu_minT();
                break;
             case 4: //manualni provoz cerpadla
                menu_manual();
                break;
             case 5: //nastaveni podsviceni
                menu_backlight();
                break;
        }
        break;
      }        
      lcd.clear();
  } while (showStatus);
}
 
//===================================================================
void menu_teplotaTUV() {
  int hodnota = PozTepl; 
    do {
    lcd.clear();
    PrintLCDAt_P(offset, 0, 0);
    lcd.setCursor(1,1);
    lcd.print(hodnota);
    lcd.write(3);//znacka stupne
    lcd.print("C");
    whichkey = PollKey();
    switch(whichkey) {
       case KeyDown:
         if (hodnota > 30) hodnota--; break;
       case KeyUp:  
         if (hodnota < 80) hodnota++; break;
       case KeySel: 
         PozTepl = hodnota; 
         EEPROM_writeAnything(10,PozTepl); 
         ulozeno(); break;//uloz do eeprom 
       case KeyExit: mainMenu(); break;//zpet do menu
    }
  } while (showStatus);
}

//===================================================================
void menu_hysTUV() {
 int hodnota = HystTUV; 
  do {
    lcd.clear();
    PrintLCDAt_P(offset, 0, 0);
    lcd.setCursor(0,1);
    if (hodnota >=0 && hodnota<10) lcd.print(" "); //zapise mezeru pred jednomistne cislo
    lcd.print(hodnota);
    lcd.write(3);//znacka stupne
    lcd.print("C");
    whichkey = PollKey();
    switch(whichkey) {
       case KeyDown:
         if (hodnota > 0) hodnota--; break;
       case KeyUp:  
         if (hodnota < 4) hodnota++; break;
       case KeySel: 
         HystTUV = hodnota; 
         EEPROM_writeAnything(40,HystTUV); 
         ulozeno(); break;//uloz do eeprom
       case KeyExit: mainMenu(); break;//zpet do menu
    }
  } while (showStatus);
}
  
//===================================================================

void menu_hysKotelTUV() {
  int hodnota = HystKotel; 
  do {
    lcd.clear();
    PrintLCDAt_P(offset, 0, 0);
    lcd.setCursor(0,1);
    if (hodnota >=0 && hodnota<10) lcd.print(" "); //zapise mezeru pred jednomistne cislo
    lcd.print(hodnota);
    lcd.write(3);//znacka stupne
    lcd.print("C");
    whichkey = PollKey();
    switch(whichkey) {
       case KeyDown:
         if (hodnota > 0) hodnota--; break;
       case KeyUp:  
         if (hodnota < 10) hodnota++; break;
       case KeySel: 
         HystKotel = hodnota; 
         EEPROM_writeAnything(30,HystKotel); 
         ulozeno(); break;//uloz do eeprom
       case KeyExit: mainMenu(); break;//zpet do menu
    }
  } while (showStatus);
}
  
//===================================================================

void menu_minT() {
 int hodnota = MinTepl; 
  do {
    lcd.clear();
    PrintLCDAt_P(offset, 0, 0);
    lcd.setCursor(1,1);
    lcd.print(hodnota);
    lcd.write(3);//znacka stupne
    lcd.print("C");
    whichkey = PollKey();
    switch(whichkey) {
       case KeyDown:
         if (hodnota > 35) hodnota--; break;
       case KeyUp:  
         if (hodnota < 45) hodnota++; break;
       case KeySel: 
         MinTepl = hodnota; 
         EEPROM_writeAnything(20,MinTepl); 
         ulozeno(); break;//uloz do eeprom
       case KeyExit: mainMenu(); break;//zpet do menu
    }
  } while (showStatus); 
}
  
//===================================================================

void menu_manual() {
 digitalWrite(cerp,LOW); 
 StavCerp = false;
 lcd.clear();
  do {
    PrintLCDAt_P(offset, 0, 0);
    lcd.setCursor(0,1);
    if (StavCerp) lcd.print("cerpadlo ON ");
    else lcd.print("cerpadlo OFF");
    
    whichkey = KeyScan(); //rucni ovladani cerpadla mimo logiku
    switch(whichkey) {
       case KeyDown: digitalWrite(cerp,LOW); StavCerp = false; break;
       case KeyUp:   digitalWrite(cerp,HIGH); StavCerp = true; break;
       case KeySel: break;
       case KeyExit: mainMenu(); break;//zpet do menu
    }
  } while (showStatus);  
}

//===================================================================
void menu_backlight() {
  int hodnota = backlight; 
  do {
    lcd.clear();
    PrintLCDAt_P(offset, 0, 0);
    lcd.setCursor(0,1);
    if (hodnota >=0 && hodnota<10) lcd.print(" "); //zapise mezeru pred jednomistne cislo
    lcd.print(hodnota);
    whichkey = PollKey();
    switch(whichkey) {
       case KeyDown:
         if (hodnota > 1) hodnota--; backlight = hodnota; break;
       case KeyUp:  
         if (hodnota < 10) hodnota++; backlight = hodnota; break;
       case KeySel: 
         backlight = hodnota; 
         EEPROM_writeAnything(50,backlight); 
         ulozeno(); break;//uloz do eeprom
       case KeyExit: mainMenu(); break;//zpet do menu
    }
   } while (showStatus);
}

//====================================================================
// vypis textu ulozeno na LCD

void ulozeno(){
  lcd.clear();
  PrintLCDAt_P(7,0,0);
  delay(500);
  showStatus=false;
}

//===================================================================

void PrintLCDAt(char *inStr, char x, char y) {
  lcd.setCursor( x,y ); 
   delay(20);
 lcd.print(inStr);
   delay(40);
}
//=================================================================== 

void PrintLCDAt_P(int which, char x, char y) {
  lcd.setCursor( x,y );  
   delay(20);
   PrintLCD_P(which);  
}
//=================================================================== 

void PrintLCD_P(int which) {
   char buffer[21];
   strcpy_P(buffer, (char*)pgm_read_word(&(StringTable[which])));
   lcd.print(buffer);
   delay(40);
}
 
//===================================================================
//kontroluje analog. hodnotu stisknuteho tlacitka

char KeyScan() {
   int which, which2, diff,retVal;
   which = analogRead(Buttons);
   //Serial.println(which); //DEBUG posle zmerenou hodnotu stisk. tlacitka
   delay(10);
   which2 = analogRead(Buttons);
   retVal = KeyInv;
   diff = abs(which - which2);
   if (diff < 12) {
 
      if (which > 900 && which < 1024) retVal = KeySel;
      if (which > 600 && which < 750) retVal =  KeyDown;
      if (which > 400 && which < 550) retVal =  KeyUp;
      if (which > 210 && which < 300) retVal =  KeyExit;
 }
   return retVal;
}

//================================================================== 
//pri pohybu v Menu ceka na platnou hodnotu tlacitka, meri teploty, 
// ovlada cerpadlo, nastavuje podsviceni

char PollKey() {
  char Whichkey;
    do {
     Whichkey = KeyScan();
     delay(60);
     zmer_teploty();
     ovl_cerp();
     set_backlight();
     //pri necinnosti v menu zped na hlavni obrazovku
     if (millis() > (menuTime + menuTimeExit)) showStatus = false;

} while ((Whichkey==KeyInv) && showStatus);
  menuTime = millis();
  delay(80);
  return Whichkey;
}
 

